#pragma semicolon 1
#include <sourcemod>

public Plugin:myinfo = 
{
	name	= "Rules",
	author	= "wS (World-Source.Ru)",
	version = "1.1"
};

new Handle:g_hMenu, Handle:g_hCvarTitle;
new g_AutoOpenSec;

public OnPluginStart()
{
	///
	g_hCvarTitle	= CreateConVar("rules_menu_title", "Правила Сервера:");
	HookConVarChange(g_hCvarTitle,	title_changed);

	new Handle:cvar	= CreateConVar("rules_menu_autoopen", "15", "Показывать правила после входа на сервер в течение 'x' сек (0 откл)");
	g_AutoOpenSec	= GetConVarInt(cvar); HookConVarChange(cvar, autoopen_changed);

	AutoExecConfig(true, "rules",	"rules");
	///

	RegConsoleCmd("rules",			rules);
	RegServerCmd("rules_reload",	rules_reload);

	wS_ReloadRules();
}

public title_changed(Handle:cvar, const String:OldValue[], const String:NewValue[])
{
	if (g_hMenu != INVALID_HANDLE) SetMenuTitle(g_hMenu, "%s\n \n", NewValue);
}

public autoopen_changed(Handle:cvar, const String:OldValue[], const String:NewValue[])
{
	g_AutoOpenSec = StringToInt(NewValue);
}

public OnClientPutInServer(client)
{
	if (g_AutoOpenSec > 0 && g_hMenu != INVALID_HANDLE)
		DisplayMenu(g_hMenu, client, g_AutoOpenSec);
}


///


public Action:rules(client, args)
{
	if (client > 0)
	{
		if (g_hMenu != INVALID_HANDLE) DisplayMenu(g_hMenu, client, 0);
		else PrintToChat(client, "Правил нет");
	}
	return Plugin_Handled;
}

public Action:rules_reload(args)
{
	if (wS_ReloadRules()) PrintToServer("Правила успешно изменены");
	return Plugin_Handled;
}


///


stock bool:wS_ReloadRules()
{
	if (g_hMenu != INVALID_HANDLE)
	{
		CloseHandle(g_hMenu);
		g_hMenu = INVALID_HANDLE;
	}

	new Handle:file = OpenFile("cfg/rules/rules.txt", "rt");
	if (file != INVALID_HANDLE)
	{
		decl String:text[75];
		while (!IsEndOfFile(file) && ReadFileLine(file, text, 75))
		{
			if (TrimString(text) > 0)
			{
				if (g_hMenu == INVALID_HANDLE)
				{
					g_hMenu = CreateMenu(wS);
					decl String:title[75]; GetConVarString(g_hCvarTitle, title, 75);
					SetMenuTitle(g_hMenu, "%s\n \n", title);
				}
				AddMenuItem(g_hMenu, "", text, ITEMDRAW_DISABLED);
			}
		}
		CloseHandle(file);
		return true;
	}

	PrintToServer("OpenFile error: cfg/rules/rules.txt");
	return false;
}

public wS(Handle:menu, MenuAction:action, client, item)
{
}